unit frmSpelunkSample;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TMyObject = class
    AString: string;
    ANumber: Integer;
  end;

  TSpelunkSampleForm = class(TForm)
    DoSomethingButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure DoSomethingButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FMyObjects: TList;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SpelunkSampleForm: TSpelunkSampleForm;

implementation

{$R *.dfm}

const
  SomeWords: array[0..6] of string = ('memory','delphi','spelunk','caving','troglodyte','cave troll','programmer');

procedure TSpelunkSampleForm.FormCreate(Sender: TObject);
var
  i: Integer;
  m: TMyObject;
begin
  FMyObjects := TList.Create;

  for i := Low(SomeWords) to High(SomeWords) do
  begin
    m := TMyObject.Create;
    m.AString := SomeWords[i];
    m.ANumber := i;
    FMyObjects.Add(m);
  end;
end;

procedure TSpelunkSampleForm.FormDestroy(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to FMyObjects.Count - 1 do
    TMyObject(FMyObjects[i]).Free;
  FMyObjects.Free;
end;

procedure TSpelunkSampleForm.DoSomethingButtonClick(Sender: TObject);
var
  i: Integer;
begin
  i := Random(FMyObjects.Count);
  TMyObject(FMyObjects[i]).Free;
  FMyObjects.Delete(i);

  ShowMessage('Time to attach a debugger -- or generate a dump file!');
end;


end.
